<template>
  <el-form ref="form" :model="form" :rules="rules">
    <ele-pro-table
      ref="table"
      :needPage="false"
      :columns="columns"
      :datasource="form.datasource"
      @columns-change="handleColumnChange"
      :cache-key="cacheKeyUrl"
      class="time-form"
    >
      <!-- 表头工具栏 -->
      <template v-slot:toolbar>
        <div
          class="headbox"
          :style="{
            justifyContent: type != '10' ? 'space-between' : 'flex-end'
          }"
        >
          <el-button
            size="small"
            type="primary"
            icon="el-icon-plus"
            class="ele-btn-icon"
            @click="handlAdd"
            v-if="type != '10'"
            >新增
          </el-button>
          <div class="pricebox">
            <span class="amount">总金额{{ totalAmount }}元</span>
          </div>
        </div>
      </template>
      <!--   发货总重   -->
      <template v-slot:sendTotalWeight="scope">
        <el-form-item
          style="margin-bottom: 20px"
          :prop="'datasource.' + scope.$index + '.sendTotalWeight'"
          :rules="[
            {
              required: pricingWay == 2 && [3, 1].includes(returnSourceType),
              message: '请输入数字',
              trigger: 'blur'
            }
          ]"
        >
          <el-input
            v-model="scope.row.sendTotalWeight"
            @blur="changeSendTotalWeight(scope.$index)"
            :disabled="returnSourceType == 2"
            style="width: 60%; margin-right: 10px"
          >
          </el-input>
          <el-button
            size="small"
            type="primary"
            v-if="[3, 1].includes(returnSourceType)"
            @click.native="(e) => handleOutBound(e, scope.row, scope.$index)"
            >选择
          </el-button>
        </el-form-item>
      </template>

      <!--        3. 按重量 发货总重必填

                   按数量 发货总重不必填

                   如果选择的订单是受托：
                   按重量 收货总重必填且可以选择
                   按数量 收货总重不必填且可以选择
                   如果不是收货总重置灰

                   -->
      <!--        1. 按重量 发货总重必填
             按数量 发货总重不必填
              如果选择的订单是受托：
             按重量 收货总重必填且可以选择
             按数量 收货总重不必填且可以选择
             如果不是收货总重置灰
               -->

      <!--        2. 按重量/按数量 发货总重置灰
                   按重量 收货总必填     -->
      <!--   收货总重   -->
      <template v-slot:receiveTotalWeight="scope">
        <el-form-item
          style="margin-bottom: 20px"
          :prop="'datasource.' + scope.$index + '.receiveTotalWeight'"
          :rules="[
            {
              required:
                (entrustedCode || returnSourceType == 2) && pricingWay == 2,
              message: '请输入数字',
              trigger: 'blur'
            }
          ]"
        >
          <el-input
            v-model="scope.row.receiveTotalWeight"
            :disabled="[3, 1].includes(returnSourceType) && !entrustedCode"
            @blur="changeReceiveTotalWeight(scope.$index)"
            style="width: 60%; margin-right: 10px"
          >
          </el-input>
          <el-button
            size="small"
            type="primary"
            v-if="entrustedCode || returnSourceType == 2"
            @click.native="(e) => handleInnerBound(e, scope.row, scope.$index)"
            >选择
          </el-button>
        </el-form-item>
      </template>
      <template v-slot:technicalDrawings="{ row, $index }">
        <el-form-item
          style="margin-bottom: 20px"
          :prop="'datasource.' + $index + '.technicalDrawings'"
        >
          <div v-if="row.technicalDrawings && row.technicalDrawings?.length">
            <el-link
              v-for="link in row.technicalDrawings"
              :key="link.id"
              type="primary"
              :underline="false"
              @click="downloadFile(link)"
            >
              {{ link.name }}
            </el-link>
          </div>
        </el-form-item>
      </template>
      <template v-slot:returnReason="{ row, $index }">
        <el-form-item
          style="margin-bottom: 20px"
          :prop="'datasource.' + $index + '.returnReason'"
        >
          <el-input
            clearable
            v-model="row.returnReason"
            type="textarea"
            placeholder="请输入"
          />
        </el-form-item>
      </template>
      <template v-slot:remark="{ row, $index }">
        <el-form-item
          style="margin-bottom: 20px"
          :prop="'datasource.' + $index + '.remark'"
        >
          <el-input
            clearable
            v-model="row.remark"
            type="textarea"
            placeholder="请输入"
          />
        </el-form-item>
      </template>

      <template v-slot:totalCount="scope">
        <el-form-item
          style="margin-bottom: 20px"
          :prop="'datasource.' + scope.$index + '.totalCount'"
          :rules="[
            { required: true, message: '请输入数字', trigger: 'blur' },
            { validator: validateTotalCount(scope.row), trigger: 'blur' }
          ]"
        >
          <el-input
            v-model="scope.row.totalCount"
            @input="(val) => changeNum(val, scope.$index)"
          ></el-input>
        </el-form-item>
      </template>

      <template v-slot:totalPrice="{ row, $index }">
        <el-form-item
          v-if="row.pricingWay == 2"
          :prop="'datasource.' + $index + '.totalPrice'"
        >
          <el-input
            type="number"
            v-model="row.totalPrice"
            placeholder="请输入"
          />
        </el-form-item>
        <span v-else>{{ row.totalPrice }}</span>
      </template>
      <template v-slot:notaxSinglePrice="scope">
        <el-form-item
          style="margin-bottom: 20px"
          :prop="'datasource.' + scope.$index + '.notaxSinglePrice'"
        >
          <el-input
            v-model="scope.row.notaxSinglePrice"
            placeholder="请输入"
            type="number"
          >
            <template slot="append">元</template>
          </el-input>
        </el-form-item>
      </template>
      <template v-slot:headerTotalCount="{ column }">
        <span class="is-required">{{ column.label }}</span>
      </template>

      <template v-slot:headerSendTotalWeight="{ column }">
        <span
          :class="{
            'is-required': pricingWay == 2 && [3, 1].includes(returnSourceType)
          }"
          >{{ column.label }}</span
        >
      </template>
      <template v-slot:headerReceiveTotalWeight="{ column }">
        <span
          :class="{
            'is-required':
              (entrustedCode || returnSourceType == 2) && pricingWay == 2
          }"
          >{{ column.label }}</span
        >
      </template>
      <!-- 操作列 -->

      <template v-slot:action="{ $index }">
        <el-popconfirm
          v-if="type != '10'"
          class="ele-action"
          title="确定要删除吗？"
          @confirm="remove($index)"
        >
          <template v-slot:reference>
            <el-link type="danger" :underline="false" icon="el-icon-delete">
              删除
            </el-link>
          </template>
        </el-popconfirm>
      </template>
    </ele-pro-table>

    <product-list
      ref="productListRef"
      :orderId="sendId"
      type="send"
      @changeParent="changeParent"
    ></product-list>
    <!--出库详情-->
    <outbound-details-dialog
      v-if="outboundDetailsDialogFlag"
      ref="outboundDetailsDialogRef"
      :outboundDetailsDialogFlag.sync="outboundDetailsDialogFlag"
      @saveDate="saveDate"
    ></outbound-details-dialog>
    <!--入库详情-->
    <innertboundDetailsDialog
      v-if="innerboundDetailsDialogFlag"
      ref="innerboundDetailsDialogRef"
      :innerboundDetailsDialogFlag.sync="innerboundDetailsDialogFlag"
      @saveDate="saveInnerDate"
    ></innertboundDetailsDialog>
  </el-form>
</template>
<script>
  import { numberReg } from 'ele-admin';
  import dictMixins from '@/mixins/dictMixins';
  import productList from '@/views/saleManage/saleOrder/invoice/components/product-list.vue';
  import { getFile } from '@/api/system/file';
  import outboundDetailsDialog from '@/views/purchasingManage/purchaseOrder/invoice/components/outboundDetailsDialog.vue';
  import innertboundDetailsDialog from '@/views/purchasingManage/purchaseOrder/returnGoods/components/innerboundDetailsDialog.vue';
  import tabMixins from '@/mixins/tableColumnsMixin';

  export default {
    mixins: [dictMixins, tabMixins],
    props: {
      sendId: String,
      pricingWay: {
        default: 1,
        type: [Number, String]
      },
      returnSourceType: [Number, String],
      entrustedCode: [Number, String],
      sendNo: [Number, String],
      returnType: {
        default: ''
      },
      type: {
        default: ''
      }
    },

    components: {
      innertboundDetailsDialog,
      outboundDetailsDialog,
      productList
    },
    data() {
      const defaultForm = {
        key: null,
        endTime: '',
        isFirst: 0,
        name: '',
        startTime: '',
        workHour: '',
        technicalDrawings: []
      };
      return {
        cacheKeyUrl: 'eos-saleManage-returnorder-inventoryTable',
        payAmount: '',
        outboundDetailsDialogFlag: false,
        innerboundDetailsDialogFlag: false,
        numberReg,
        defaultForm,
        form: {
          datasource: []
        },
        rules: {},
        oldSendTotalWeightList: [],

        columns: [
          {
            width: 45,
            type: 'index',
            columnKey: 'index',
            align: 'center',
            fixed: 'left'
          },
          {
            minWidth: 160,
            prop: 'productCode',
            label: '编码',
            showOverflowTooltip: true,
            align: 'center'
          },
          {
            minWidth: 120,
            prop: 'productName',
            label: '名称',
            showOverflowTooltip: true,
            align: 'center'
          },

          {
            minWidth: 160,
            prop: 'batchNo',
            label: '批次号',
            showOverflowTooltip: true,
            slot: 'batchNo',
            align: 'center'
          },
          {
            minWidth: 160,
            prop: 'barcodes',
            label: '发货条码',
            showOverflowTooltip: true,
            slot: 'barcodes',
            align: 'center'
          },
          {
            minWidth: 120,
            prop: 'materielDesignation',
            label: '物料代号',
            showOverflowTooltip: true,
            align: 'center'
          },
          {
            minWidth: 120,
            prop: 'clientCode',
            label: '客户代号',
            showOverflowTooltip: true,
            align: 'center'
          },
          {
            minWidth: 120,
            prop: 'engrave',
            label: '刻码',
            showOverflowTooltip: true,
            align: 'center'
          },
          {
            minWidth: 160,
            prop: 'packageNo',
            align: 'center',
            label: '包装编码',
            showOverflowTooltip: true
          },
          {
            minWidth: 100,
            prop: 'packingQuantity',
            align: 'center',
            label: '包装数量',
            showOverflowTooltip: true
          },
          {
            minWidth: 120,
            prop: 'packingUnit',
            align: 'center',
            label: '包装单位',
            showOverflowTooltip: true
          },
          {
            minWidth: 100,
            prop: 'totalCount',
            label: '计量数量',
            showOverflowTooltip: true,
            align: 'center'
          },
          {
            minWidth: 150,
            prop: 'measuringUnit',
            label: '计量单位',
            showOverflowTooltip: true,
            align: 'center'
          },
          {
            width: 160,
            prop: 'pricingWay',
            label: '计价方式',
            slot: 'pricingWay',
            align: 'center',
            formatter: (row, column) => {
              return row.pricingWay == 1
                ? '按数量计费'
                : row.pricingWay == 2
                ? '按重量计费'
                : '';
            }
          },
          {
            width: 100,
            prop: 'singlePrice',
            label: '单价',
            slot: 'singlePrice',
            align: 'center'
          },
          {
            width: 180,
            prop: 'notaxSinglePrice',
            label: '不含税单价',
            slot: 'notaxSinglePrice',
            align: 'center'
          },
          {
            width: 120,
            prop: 'totalPrice',
            slot: 'totalPrice',
            label: '合计',
            align: 'center'
          },
          // {
          //   minWidth: 80,
          //   prop: 'weight',
          //   label: '重量',
          //   showOverflowTooltip: true,
          //   align: 'center'
          // },
          {
            minWidth: 120,
            prop: 'receiveTotalWeight',
            label: '重量',
            // slot: 'singleWeight',
            showOverflowTooltip: true,
            align: 'center'
          },
          {
            minWidth: 100,
            prop: 'weightUnit',
            label: '重量单位',
            showOverflowTooltip: true,
            align: 'center'
          },
          {
            prop: 'provenance',
            label: '产地',
            slot: 'provenance',
            align: 'center',
            minWidth: 200,
            showOverflowTooltip: true,
            formatter: (row, column) => {
              return row.provenance && row.provenance.length
                ? row.provenance
                    .map((item) => this.getDictValue('产地', item))
                    .join(',')
                : '';
            }
          },
          {
            minWidth: 100,
            prop: 'renturnType',
            label: '状态',
            showOverflowTooltip: true,
            align: 'center'
          },

          {
            minWidth: 200,
            prop: 'returnReason',
            label: '退货原因',
            slot: 'returnReason',
            align: 'center'
          },

          {
            width: 220,
            prop: 'remark',
            label: '备注',
            slot: 'remark',
            align: 'center'
          },
          {
            columnKey: 'action',
            label: '操作',
            width: 120,
            align: 'center',
            resizable: false,
            slot: 'action',
            fixed: 'right',
            showOverflowTooltip: true
          }
        ]
      };
    },
    created() {
      this.requestDict('产地');
    },
    computed: {
      totalAmount() {
        let num = 0;
        this.form.datasource.forEach((item, index) => {
          if (item.pricingWay == 1) {
            this.$set(
              this.form.datasource[index],
              'totalPrice',
              item.singlePrice * item.totalCount || 0
            );
          }

          if (item.totalPrice) {
            num += Number(item.totalPrice);
          }
        });
        return num;
      }
    },
    mounted() {
      console.log(this.entrustedCode);
    },
    methods: {
      downloadFile(file) {
        getFile({ objectName: file.storePath }, file.name);
      },

      //出库单详情
      handleOutBound(e, rows, index) {
        this.curIndex = index;
        this.outboundDetailsDialogFlag = true;
        this.$nextTick(() => {
          let row = {
            sendNo: this.entrustedCode || this.sendNo,
            productCode: rows.productCode
          };
          this.$refs.outboundDetailsDialogRef.init(row);
        });
      },
      //选择退货信息回调
      saveDate(data = []) {
        let totalWeight = data.reduce((num, row) => {
          num += Number(row.weight);
          return num;
        }, 0);
        this.$set(
          this.form.datasource[this.curIndex],
          'sendTotalWeight',
          totalWeight
        );
        this.setIcreaseTotalWeight();
      },

      //入库单详情
      handleInnerBound(e, rows, index) {
        this.curIndex = index;
        this.innerboundDetailsDialogFlag = true;
        this.$nextTick(() => {
          let row = {
            sendNo: this.entrustedCode,
            productCode: rows.productCode
          };
          this.$refs.innerboundDetailsDialogRef.init(row);
        });
      },
      //选择入库单信息
      saveInnerDate(data = []) {
        let totalWeight = data.reduce((num, row) => {
          num += Number(row.weight);
          return num;
        }, 0);
        this.$set(
          this.form.datasource[this.curIndex],
          'receiveTotalWeight',
          totalWeight
        );
        if (this.returnSourceType == 2)
          this.$set(
            this.form.datasource[this.curIndex],
            'sendTotalWeight',
            totalWeight
          );
        this.setIcreaseTotalWeight();
      },
      //修改发货总重
      changeSendTotalWeight(index) {
        this.curIndex = index;
        this.setIcreaseTotalWeight();
      },
      //修改收货总重
      changeReceiveTotalWeight(index) {
        this.curIndex = index;
        if (this.returnSourceType == 2)
          this.form.datasource[this.curIndex].sendTotalWeight =
            this.form.datasource[this.curIndex].receiveTotalWeight;
        this.setIcreaseTotalWeight();
      },
      //设置增重总重
      setIcreaseTotalWeight() {
        let sendTotalWeight = Number(
          this.form.datasource[this.curIndex].sendTotalWeight
        );
        let receiveTotalWeight = Number(
          this.form.datasource[this.curIndex].receiveTotalWeight
        );
        // if (this.entrustedCode) {
        if (this.pricingWay == 2) {
          if (isNaN(receiveTotalWeight) || isNaN(sendTotalWeight)) {
            return this.$set(
              this.form.datasource[this.curIndex],
              'increaseTotalWeight',
              ''
            );
          } else {
            this.$set(
              this.form.datasource[this.curIndex],
              'increaseTotalWeight',
              (sendTotalWeight - receiveTotalWeight).toFixed(2)
            );
          }
        } else {
          this.$set(
            this.form.datasource[this.curIndex],
            'increaseTotalWeight',
            (sendTotalWeight - receiveTotalWeight).toFixed(2)
          );
        }
        // } else {
        //   this.$set(this.form.datasource[this.curIndex], 'increaseTotalWeight', sendTotalWeight);
        // }
        if (this.pricingWay == 2) {
          this.getWeightPrice();
        }
        this.$refs.table.reload();
      },
      //获取订单总金额
      gettotalAmount() {
        let productData = this.form.datasource;
        if (productData.length) {
          let sum = productData
            .reduce((sum, item) => {
              return sum + Number(item.totalPrice);
            }, 0)
            .toFixed(2);
          this.payAmount = productData
            .reduce((sum, item) => {
              return sum + Number(item.discountTotalPrice);
            }, 0)
            .toFixed(2);
          this.$emit('update:payAmount', this.payAmount);
          this.$store.commit('returnGoods/setAllcountAmount', sum);
        } else {
          this.$store.commit('returnGoods/setAllcountAmount', 0);
        }
      },
      //选择产品回调
      async changeParent(obj, idx) {
        console.log(obj, '9999');
        obj.sendTotalCount = obj.totalCount;
        obj.sendProductId = obj.id;
        obj.id = '';

        // if (obj.warehouseId) {
        //   obj['warehouseNum'] = await getWarehouseOutStock({
        //     warehouseId: obj.warehouseId,
        //     code: obj.productCode
        //   });
        // }
        this.$set(this.form.datasource, this.form.datasource.length, obj);
      },
      validateTotalCount(row) {
        return (rule, value, callback) => {
          if (isNaN(value) || Number(value) <= 0) {
            this.$message.error('请输入大于0的数');
            callback(new Error('请输入大于0的数字'));
          } else if (Number(value) > row.sendTotalCount) {
            this.$message.error('输入的数字不能大于最大发货值');
            callback(new Error('输入的数字不能大于最大发货值'));
          } else {
            callback();
          }
        };
      },
      getTotalCount(row) {
        let num = 0;
        this.form.datasource
          .filter((item) => item.warehouseId == row.warehouseId)
          .forEach((item) => {
            num += Number(item.totalCount);
          });

        return num;
      },
      // 返回列表数据
      getTableValue() {
        let is = false;
        this.form.datasource.forEach((item) => {
          if (item.pricingWay == 2 && !item.totalPrice) {
            is = true;
          }
        });
        if (is) {
          this.$message.error('合计金额不能为空');
          return;
        }
        let comitDatasource = this.form.datasource;
        if (comitDatasource.length === 0) return { productList: [] };
        comitDatasource.forEach((v) => {
          v.totalCount = Number(v.totalCount);
          v.technicalDrawings = Array.isArray(v.technicalDrawings)
            ? v.technicalDrawings
            : [];
        });
        return { productList: comitDatasource, payAmount: this.totalAmount };
      },
      getPrice() {
        return [this.allPrice];
      },

      //修改回显
      putTableValue(data) {
        if (data) {
          data.forEach((v) => {
            // v.returnReason = v.returnReason || '';
            // v.returnType = '';
            v.sendTotalCount = v.packingQuantity || 0;
            v.sendProductId = v.sendProductId || v.categoryId || v.productId;
          });
          this.oldSendTotalWeightList = data.map((item) => {
            return {
              productCode: item.productCode,
              oldSendTotalWeight: item.sendTotalWeight,
              oldReceiveTotalWeight: item.receiveTotalWeight
            };
          });
          this.form.datasource = data;
          // this.form.datasource.forEach(async (v, index) => {
          //   if (v.warehouseId) {
          //     this.$set(
          //       this.form.datasource[index],
          //       'warehouseNum',
          //       await getWarehouseOutStock({
          //         warehouseId: v.warehouseId,
          //         code: v.productCode
          //       })
          //     );
          //   }
          // });
          this.gettotalAmount();
        }
      },

      remove(index) {
        this.form.datasource.splice(index, 1);
        this.setSort();
        this.gettotalAmount();
      },
      // 清空表格
      restTable() {
        this.form.datasource = [];
      },
      // 重新排序
      setSort() {
        this.form.datasource.forEach((n, index) => {
          n.key = index + 1;
        });
      },
      // 添加
      handlAdd() {
        if (!this.sendId && !this.entrustedCode)
          return this.$message.error('请先选择来源单据');
        this.$emit('handleSelectGoods', this.form.datasource);
        // this.$refs.productListRef.open(this.form.datasource);
      },

      validateForm(callback) {
        //开始表单校验
        this.$refs.form.validate((valid) => {
          callback(valid);
        });
      }
    }
  };
</script>
<style lang="scss" scoped>
  .headbox {
    display: flex;
    justify-content: space-between;
    align-items: center;

    .amount {
      font-size: 14px;
      font-weight: bold;
      padding-right: 30px;
    }
  }

  .time-form .el-form-item {
    margin-bottom: 0 !important;
  }

  ::v-deep .period {
    display: flex;

    .borderleftnone {
      .el-input--medium .el-input__inner {
        border-top-right-radius: 0;
        border-bottom-right-radius: 0;
      }
    }

    .borderrightnone {
      .el-input--medium .el-input__inner {
        border-top-left-radius: 0;
        border-bottom-left-radius: 0;
      }
    }
  }

  ::v-deep .time-form tbody > tr:hover > td {
    background-color: transparent !important;
  }

  ::v-deep .time-form .el-table tr {
    background-color: #ffffff;
  }

  .pricebox {
    display: flex;
    justify-content: flex-start;
    align-items: center;
    font-weight: bold;
  }
</style>
